'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _index = require('./index');

var _index2 = _interopRequireDefault(_index);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function noop() {}

var DataSource = function () {
  DataSource.prototype.init = function init(config) {
    this.fetcher = config.fetcher || noop;
    this.resolve = config.resolve || noop;
    this.getParams = config.getParams || noop;
    this.getPagination = config.getPagination || noop;
    this.extraParams = config.extraParams || {};
    this.needUpdate = config.needUpdate || false;
    this.remotes = config.remotes || {}; // 远程返回数据
  };

  function DataSource(config) {
    _classCallCheck(this, DataSource);

    if (config) {
      this.init(config);
    }
  }

  return DataSource;
}();

/* eslint react/prefer-es6-class: 0 */


var AntTableV2 = _react2["default"].createClass({
  displayName: 'AntTableV2',

  propTypes: {
    dataSource: _react2["default"].PropTypes.oneOfType([_react2["default"].PropTypes.array, _react2["default"].PropTypes.instanceOf(DataSource)])
  },
  isLocalDataSource: function isLocalDataSource(dataSource) {
    return Array.isArray(dataSource);
  },
  fetch: function fetch() {
    var params = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];
    var dataSource = this.props.dataSource;

    var builtinParams = _extends({}, params, dataSource.extraParams);
    return dataSource.fetcher(builtinParams);
  },
  handleTableChange: function handleTableChange(pagination, filters, sorter) {
    var dataSource = this.props.dataSource;

    var builtinParams = dataSource.getParams.call(this, pagination, filters, sorter);
    this.fetch(builtinParams);
  },
  resolveCurrent: function resolveCurrent(total, current, pageSize) {
    // 删除完一页时返回上一页
    return total > 0 && (current - 1) * pageSize === total ? current - 1 : current;
  },
  render: function render() {
    var dataSource = this.props.dataSource;
    var pagination = this.props.pagination;
    if (dataSource && !this.isLocalDataSource(dataSource)) {
      var data = dataSource.resolve(dataSource.remotes);
      pagination = pagination !== false ? _extends({}, pagination, dataSource.getPagination(dataSource.remotes, this.resolveCurrent)) : pagination;
      dataSource = data;
    }
    return _react2["default"].createElement(_index2["default"], _extends({}, this.props, { dataSource: dataSource, pagination: pagination,
      onChange: this.handleTableChange }));
  }
});

AntTableV2.DataSource = DataSource;
exports["default"] = AntTableV2;
module.exports = exports['default'];